con
  _CLKMODE      = XTAL1 + PLL16X
  _XINFREQ      = 5_000_000

  'For BenkyLCDDriver
  LCDBasePin    = 0

  'For LCD_Nx2
  RS = 0      ' 1
  RW = 1      ' 2
  E  = 2      ' 3
  DBLow  = 3   ' 0
  DBHigh = 6

  lineLen       = 14

obj
  LCDb: "BenkyLCDdriver"
  LCDn : "LCD_Nx2"

pub main
  'switch at P14 determines which driver to use
  if ina[14]
    doLCDb
  else
    doLCDn

pub doLCDn | inx, let
  LCDn.Init( E, RS, RW, DBHigh, DBLow )

  LCDn.SetRowCol( 1, 0 )
  LCDn.PrintStr( @text1 )
  LCDn.SetRowCol ( 0, 0 )
  LCDn.PrintStr( @textN )
  waitcnt(clkfreq << 1 + cnt)
  dira[11]~~

  repeat
    repeat let from "!" to "~"
      repeat inx from 0 to lineLen - 1
        scrbuf[inx] := let
      LCDn.SetRowCol( 0, 0 )
      LCDn.PrintStr( @scrbuf )
      waitcnt(clkfreq >> 2 + cnt)
      LCDn.SetRowCol( 1, 0 )
      LCDn.PrintStr( @scrbuf )
      waitcnt(clkfreq >> 2 + cnt)
      !outa[11]

pub doLCDb | inx, let
  LCDb.start( LCDBasePin,0 )

  LCDb.exec(LCDb#CMD_INSTR, %1000_0000 + $40) ' set the display RAM address to $40
  LCDb.exec(LCDb#CMD_PRINT, @text1)
  LCDb.exec(LCDb#CMD_INSTR, %1000_0000) ' set the display RAM address to $00
  LCDb.exec(LCDb#CMD_PRINT, @textB)
  waitcnt(clkfreq << 1 + cnt)
  dira[11]~~

  repeat
    repeat let from "!" to "~"
      repeat inx from 0 to lineLen - 1
        scrbuf[inx] := let
      LCDb.exec(LCDb#CMD_INSTR, %1000_0000 + $40) ' set the display RAM address to $40
      LCDb.exec(LCDb#CMD_PRINT, @scrbuf)
      waitcnt(clkfreq >> 2 + cnt)
      LCDb.exec(LCDb#CMD_INSTR, %1000_0000) ' set the display RAM address to $00
      LCDb.exec(LCDb#CMD_PRINT, @scrbuf)
      waitcnt(clkfreq >> 2 + cnt)
      !outa[11]


dat
text1   byte  "First Message", 0

textN   byte  "LCD_Nx2 driver", 0
textB   byte  "BenkyLCDdriver", 0

scrbuf  byte  " "[lineLen],0

